<template>
  <div>
    <div class="bg-gradient-to-b from-cyan-500 to-blue-500">
      <app-header class="text-white px-32 py-1" />
      <search-bar
        class="container mt-20 relative -bottom-5"
        @updateHotels="updateHotels"
        @updateSearchCity="updateSearchCity"
      />
    </div>
    <div class="container mt-12">
      <div class="grid grid-cols-3 gap-3">
        <div class="col-span-1">
          <div class="bg-gray-3 p-3 rounded">
            <h5 class="mb-2 font-bold">Search by property name</h5>
            <input class="boarder" placeholder=" eg: beach" />
          </div>
          <div class="mt-5">
            <h5>Filter by</h5>
            <div class="boarder-1 shadow mt-2 rounded-md">
              <div class="bg-gray-3 boarder px-3 py-5">
                <h5 class="font-bold">Your budget per day</h5>
              </div>
              <div class="p-3">
                <input
                  class="m-2"
                  type="checkbox"
                  id="budget1"
                  name="budget1"
                  value="0-200"
                />
                <label for="budget1">$ 0- $200</label><br />
                <input
                  class="m-2"
                  type="checkbox"
                  id="budget2"
                  name="budget2"
                  value="200-500"
                />
                <label for="budget2">$ 200- $500</label><br />
                <input
                  class="m-2"
                  type="checkbox"
                  id="budget3"
                  name="budget3"
                  value="500-1000"
                />
                <label for="budget3">$ 500- $1000</label><br />
                <input
                  class="m-2"
                  type="checkbox"
                  id="budget4"
                  name="budget4"
                  value="1000-2000"
                />
                <label for="budget4">$ 1000- $2000</label><br />
                <input
                  class="m-2"
                  type="checkbox"
                  id="budget5"
                  name="budget5"
                  value="2000-5000"
                />
                <label for="budget5">$ 2000- $5000</label><br />
              </div>
              <div class="px-4 border-dashed bg-blue border-gray-1 shadow">
                <p class="text-sm py-1">Set your own budget</p>
                <div class="grid grid-cols-2 gap-4 ">
                  <input class="border-solid shadow py-2 " type="text" placeholder="Min budget">
                  <input class="border-solid shadow py-2" type="text" placeholder="Max budget">
                </div>
                <p class="text-sm pb-5 pt-3">Press Enter to filter</p>
              </div>
            </div>
          </div>
        </div>
        <div class="col-span-2">
          <div class="flex flex-row justify-between">
            <div>
              <h1 class="font-bold text-lg ml-4">
                {{ searchCity.toUpperCase() }}:{{ hotels.length }} search
                results found for {{ searchCity }}
              </h1>
            </div>
            <div class="boarder-1 shadow-md mb-4">
              <span class="block text-center">sort by</span>
              <select
                v-model="sortOption"
                class="text-sm font-semibold p-2 rounded border-none"
              >
                <option value="" disabled selected hidden>Recommended</option>
                <option v-for="sort in sortBy" :key="sort.id">
                  {{ sort.title }}
                </option>
              </select>
            </div>
          </div>
          <div
            class="grid grid-cols-3 border m-2 rounded-md shadow-md p-2"
            v-for="hotel in hotels"
            :key="hotel.hotel_id"
          >
            <div class="">
              <img class="rounded" :src="hotel.property.photoUrls[0]" />
            </div>
            <div class="flex flex-col content-center">
              <div>
                <h1 class="font-bold text-lg">{{ hotel.property.name }}</h1>
              </div>
              <div class="flex flex-row pb-2 text-sm">
                <div class="text-orange-1">
                  <i class="fa-solid fa-star"></i>
                  <i class="fa-solid fa-star"></i>
                  <i class="fa-solid fa-star"></i>
                  <i class="fa-solid fa-star"></i>
                  <i class="fa-solid fa-star-half"></i>
                </div>
                <p class="text-gray-1">4.5 stars(1200 Reviews)</p>
              </div>
              <div class="text-sm">
                <p>Live a little and celebrate with champagne</p>
                <p>
                  Treats include a glass of French champagne, parking and a late
                  checkout. Gym included. Flexible cancellation applies
                </p>
                <router-link to="/HotelDetails">
                  <button class="bg-blue-1 p-2 mt-5 rounded text-white-1">
                    See availability
                  </button>
                </router-link>
              </div>
            </div>
            <div>
              <!-- <button >Book now and receive 15% off</button> -->
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="container mt-5">
    <warning /></div>
    <app-footer />
  
  </div>
</template>

<script>
import SearchBar from "../components/global/SearchBar.vue";
import AppHeader from "../components/global/AppHeader.vue";
import Warning from "../components/global/Warning.vue";
import AppFooter from "../components/global/AppFooter.vue";

import { onBeforeMount, ref, onMounted, onUpdated } from "vue";
import axios from "axios";
export default {
  components: { AppHeader, SearchBar, AppFooter, Warning },
  setup() {
    const error = ref(null);
    const hotels = ref([]);
    let searchCity = ref("");
    const sortBy = ref("");
    const sortOption = ref("");
    const budgets=ref([])
    const key=import.meta.env.VITE_RAPID_API_KEY
    const updateHotels = (updatedHotels) => {
      hotels.value = updatedHotels;
    };
    const updateSearchCity = (updateSearchCity) => {
      searchCity.value = updateSearchCity;
    };
    const initializeData = async () => {
      try {
        // const storedSearchCity = localStorage.getItem("searchCity");
        const storedHotels = localStorage.getItem("hotels");

        if (storedSearchCity && storedHotels) {
          // searchCity.value = storedSearchCity;
          hotels.value = JSON.parse(storedHotels);
        }
      } catch (error) {
        console.error("Error initializing data:", error);
      }
    };
    const getSortBy = async () => {
      const options = {
        method: "GET",
        url: "https://booking-com15.p.rapidapi.com/api/v1/hotels/getSortBy",
        params: {
          dest_id: localStorage.getItem("dest_id"),
          search_type: "CITY",
          arrival_date: "2023-12-05",
          departure_date: "2023-12-10",
          // adults: '1',
          // children_age: '1,17',
          // room_qty: '1'
        },
        headers: {
          "X-RapidAPI-Key":
            "697b6c9edemsh526d9e9a0a48f3bp14de13jsnfe4de2ac8fae",
          "X-RapidAPI-Host": "booking-com15.p.rapidapi.com",
        },
      };
      const response = await axios.request(options);

      // console.log("data is ", response.data.data);
      sortBy.value = response.data.data;
    };
const getBudget=async()=>{
  const options = {
  method: 'GET',
  url: 'https://booking-com15.p.rapidapi.com/api/v1/hotels/getFilter',
  params: {
    dest_id:localStorage.getItem("dest_id") ,
    search_type: 'CITY',
    arrival_date: '2023-12-05',
    departure_date: '2023-12-10',
  },
  headers: {
    'X-RapidAPI-Key': "697b6c9edemsh526d9e9a0a48f3bp14de13jsnfe4de2ac8fae",
    'X-RapidAPI-Host': 'booking-com15.p.rapidapi.com'
  }
  
};
const response = await axios.request(options);
budgets.value=response.data.data.filters
console.log(budgets.value)

}
onUpdated(()=>{
  searchCity.value=localStorage.getItem('searchCity')
})
    onMounted(() => {
      console.log(key)
      getSortBy();
      getBudget()
    });
    onBeforeMount(() => {
      initializeData();
    });
    return {
      sortOption,
      error,
      hotels,
      updateHotels,
      updateSearchCity,
      searchCity,
      sortBy,
      getSortBy,
      getBudget
    };
  },
};
</script>

<style scoped>
img {
  border-radius: 5%;
}
</style>
